<?php 
namespace Opencart\Admin\Controller\Extension\PprMkrThumbevent\Module;
class GetStatus extends \Opencart\System\Engine\Controller {
	private $error = array(); 
	private $event_list = array(
		array(
			'code' => 'pprmkr_getstatus_before',
			'trigger' => 'catalog/controller/product/thumb/before',
			'description' => 'Adds product stock to product thumb',
			'action' => 'extension/pprmkr_thumbevent/module/get_status|addTekstBefore'
		),
		array(
			'code' => 'pprmkr_getstatus_after',
			'trigger' => 'catalog/controller/product/thumb/after',
			'description' => 'Adds product stock to product thumb',
			'action' => 'extension/pprmkr_thumbevent/module/get_status|addTekst'
		)
	);
			 
	public function index() { 
		$this->load->language('extension/pprmkr_thumbevent/module/get_status');

		$this->document->setTitle($this->language->get('heading_title'));
		
  		$data['breadcrumbs'] = array();

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
   		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
		);
		
   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('extension/pprmkr_thumbevent/module/get_status', 'user_token=' . $this->session->data['user_token'], true)
   		);
   		
		$data['save'] = $this->url->link('extension/pprmkr_thumbevent/module/get_status|save', 'user_token=' . $this->session->data['user_token']);
		$data['back'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module');
		
		$data['module_get_status_status'] = $this->config->get('module_get_status_status');

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/pprmkr_thumbevent/module/get_status', $data));
	}
	
	public function save(): void {
		$this->load->language('extension/pprmkr_thumbevent/module/get_status');

		$json = [];

		if (!$this->user->hasPermission('modify', 'extension/pprmkr_thumbevent/module/get_status')) {
			$json['error']['warning'] = $this->language->get('error_permission');
		}

		if (!$json) {
			$this->load->model('setting/setting');

			$this->model_setting_setting->editSetting('module_get_status', $this->request->post);

			$json['success'] = $this->language->get('text_success');
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
	
	public function install() {
		$this->load->model('setting/event');
		
		foreach ($this->event_list as $event) {
			$this->model_setting_event->addEvent($event['code'], $event['description'], $event['trigger'], $event['action']);
		}
	}

	public function uninstall() {
		$this->load->model('setting/event');

		foreach ($this->event_list as $event) {
			$this->model_setting_event->deleteEventByCode($event['code']);
		}
	}
}